'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.exec = undefined;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var needWithDryRun = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(target) {
    var target2, result;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            target2 = (0, _assign2.default)({ dryRun: true }, target);
            _context.next = 3;
            return (0, _pkgFetch.need)(target2);

          case 3:
            result = _context.sent;

            (0, _assert2.default)(['exists', 'fetched', 'built'].indexOf(result) >= 0);
            dryRunResults[result] = true;

          case 6:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function needWithDryRun(_x) {
    return _ref.apply(this, arguments);
  };
}();

var needViaCache = function () {
  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(target) {
    var s, c;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            s = stringifyTarget(target);
            c = targetsCache[s];

            if (!c) {
              _context2.next = 4;
              break;
            }

            return _context2.abrupt('return', c);

          case 4:
            _context2.next = 6;
            return (0, _pkgFetch.need)(target);

          case 6:
            c = _context2.sent;

            targetsCache[s] = c;
            return _context2.abrupt('return', c);

          case 9:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function needViaCache(_x2) {
    return _ref2.apply(this, arguments);
  };
}();

var exec = exports.exec = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(argv2) {
    var argv, debug, forceBuild, input, inputJson, inputBin, bin, inputFin, config, configJson, output, outputDir, autoOutput, name, ext, targets, different, target, file, _iteratorNormalCompletion4, _didIteratorError4, _iteratorError4, _iterator4, _step4, _target, _file, options, _iteratorNormalCompletion5, _didIteratorError5, _iteratorError5, _iterator5, _step5, _target2, _iteratorNormalCompletion6, _didIteratorError6, _iteratorError6, _iterator6, _step6, _target3, f, _iteratorNormalCompletion7, _didIteratorError7, _iteratorError7, _iterator7, _step7, _target4, _f, tuple, records, stripes, _iteratorNormalCompletion8, _didIteratorError8, _iteratorError8, _iterator8, _step8, _target5, slash, _iteratorNormalCompletion9, _didIteratorError9, _iteratorError9, _iterator9, _step9, _target6;

    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            // eslint-disable-line complexity

            argv = (0, _minimist2.default)(argv2, {
              boolean: ['b', 'build', 'd', 'debug', 'h', 'help'],
              string: ['_', 'c', 'config', 'o', 'options', 'output', 'outdir', 'out-dir', 't', 'target', 'targets']
            });

            if (!(argv.h || argv.help)) {
              _context3.next = 4;
              break;
            }

            (0, _help2.default)();
            return _context3.abrupt('return');

          case 4:

            // debug

            debug = argv.d || argv.debug;

            _log.log.debugMode = debug;

            // forceBuild

            forceBuild = argv.b || argv.build;

            // _

            if (argv._.length) {
              _context3.next = 9;
              break;
            }

            throw (0, _log.wasReported)('Entry file/directory is expected', ['Pass --help to see usage information']);

          case 9:
            if (!(argv._.length > 1)) {
              _context3.next = 11;
              break;
            }

            throw (0, _log.wasReported)('Not more than one entry file/directory is expected');

          case 11:

            // input

            input = _path2.default.resolve(argv._[0]);
            _context3.next = 14;
            return (0, _fsPromise.exists)(input);

          case 14:
            if (_context3.sent) {
              _context3.next = 16;
              break;
            }

            throw (0, _log.wasReported)('Input file ' + input + ' does not exist');

          case 16:
            _context3.next = 18;
            return (0, _fsPromise.stat)(input);

          case 18:
            if (!_context3.sent.isDirectory()) {
              _context3.next = 24;
              break;
            }

            input = _path2.default.join(input, 'package.json');
            _context3.next = 22;
            return (0, _fsPromise.exists)(input);

          case 22:
            if (_context3.sent) {
              _context3.next = 24;
              break;
            }

            throw (0, _log.wasReported)('Input file ' + input + ' does not exist');

          case 24:

            // inputJson

            inputJson = null;

            if (!(0, _common.isPackageJson)(input)) {
              _context3.next = 31;
              break;
            }

            _context3.t0 = JSON;
            _context3.next = 29;
            return (0, _fsPromise.readFile)(input);

          case 29:
            _context3.t1 = _context3.sent;
            inputJson = _context3.t0.parse.call(_context3.t0, _context3.t1);

          case 31:

            // inputBin

            inputBin = null;

            if (!inputJson) {
              _context3.next = 41;
              break;
            }

            bin = inputJson.bin;

            if (!bin) {
              _context3.next = 41;
              break;
            }

            if ((typeof bin === 'undefined' ? 'undefined' : (0, _typeof3.default)(bin)) === 'object') {
              if (bin[inputJson.name]) {
                bin = bin[inputJson.name];
              } else {
                bin = bin[(0, _keys2.default)(bin)[0]]; // TODO multiple inputs to compile them all?
              }
            }
            inputBin = _path2.default.resolve(_path2.default.dirname(input), bin);
            _context3.next = 39;
            return (0, _fsPromise.exists)(inputBin);

          case 39:
            if (_context3.sent) {
              _context3.next = 41;
              break;
            }

            throw (0, _log.wasReported)(inputBin + ' does not exist (taken from package.json \'bin\' property)');

          case 41:
            if (!(inputJson && !inputBin)) {
              _context3.next = 43;
              break;
            }

            throw (0, _log.wasReported)('Property \'bin\' does not exist in ' + input);

          case 43:

            // inputFin

            inputFin = inputBin || input;

            // config

            config = argv.c || argv.config;

            if (!(inputJson && config)) {
              _context3.next = 47;
              break;
            }

            throw (0, _log.wasReported)('Specify either \'package.json\' or config. Not both');

          case 47:

            // configJson

            configJson = null;

            if (!config) {
              _context3.next = 56;
              break;
            }

            config = _path2.default.resolve(config);
            _context3.next = 52;
            return (0, _fsPromise.exists)(config);

          case 52:
            if (_context3.sent) {
              _context3.next = 54;
              break;
            }

            throw (0, _log.wasReported)('Config file ' + config + ' does not exist');

          case 54:
            configJson = require(config); // may be either json or js
            if (!configJson.name && !configJson.files && !configJson.dependencies && !configJson.pkg) {
              // package.json not detected
              configJson = { pkg: configJson };
            }

          case 56:

            // output, outputDir

            output = argv.o || argv.output;
            outputDir = argv.outdir || argv['out-dir'];
            autoOutput = false;

            if (!(output && outputDir)) {
              _context3.next = 61;
              break;
            }

            throw (0, _log.wasReported)('Specify either \'output\' or \'out-dir\'. Not both');

          case 61:
            if (output) {
              _context3.next = 74;
              break;
            }

            name = void 0;

            if (!inputJson) {
              _context3.next = 69;
              break;
            }

            name = inputJson.name;

            if (name) {
              _context3.next = 67;
              break;
            }

            throw (0, _log.wasReported)('Property \'name\' does not exist in ' + argv._[0]);

          case 67:
            _context3.next = 70;
            break;

          case 69:
            name = _path2.default.basename(inputFin);

          case 70:
            autoOutput = true;
            ext = _path2.default.extname(name);

            output = name.slice(0, -ext.length || undefined);
            output = _path2.default.resolve(outputDir || '', output);

          case 74:

            // targets

            targets = parseTargets(argv.t || argv.target || argv.targets);


            if (!targets.length) {
              if (!autoOutput) {
                targets = parseTargets('host');
                (0, _assert2.default)(targets.length === 1);
              } else {
                targets = parseTargets('linux,macos,win');
              }
              _log.log.info('Targets not specified. Assuming:', '' + targets.map(stringifyTarget).join(', '));
            }

            // differentParts

            different = differentParts(targets);

            // targets[].output

            if (!(targets.length === 1)) {
              _context3.next = 84;
              break;
            }

            target = targets[0];
            file = output;

            if (target.platform === 'win' && autoOutput) file += '.exe';
            target.output = file;
            _context3.next = 103;
            break;

          case 84:
            _iteratorNormalCompletion4 = true;
            _didIteratorError4 = false;
            _iteratorError4 = undefined;
            _context3.prev = 87;

            for (_iterator4 = (0, _getIterator3.default)(targets); !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
              _target = _step4.value;
              _file = stringifyTargetForOutput(output, _target, different);

              if (_target.platform === 'win') _file += '.exe';
              _target.output = _file;
            }
            _context3.next = 95;
            break;

          case 91:
            _context3.prev = 91;
            _context3.t2 = _context3['catch'](87);
            _didIteratorError4 = true;
            _iteratorError4 = _context3.t2;

          case 95:
            _context3.prev = 95;
            _context3.prev = 96;

            if (!_iteratorNormalCompletion4 && _iterator4.return) {
              _iterator4.return();
            }

          case 98:
            _context3.prev = 98;

            if (!_didIteratorError4) {
              _context3.next = 101;
              break;
            }

            throw _iteratorError4;

          case 101:
            return _context3.finish(98);

          case 102:
            return _context3.finish(95);

          case 103:

            // options

            options = argv.options || '';

            options = options.split(',').filter(function (option) {
              return option;
            }).map(function (option) {
              return '--' + option;
            });

            // check if input is going
            // to be overwritten by output

            _iteratorNormalCompletion5 = true;
            _didIteratorError5 = false;
            _iteratorError5 = undefined;
            _context3.prev = 108;
            _iterator5 = (0, _getIterator3.default)(targets);

          case 110:
            if (_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done) {
              _context3.next = 121;
              break;
            }

            _target2 = _step5.value;

            if (!(_target2.output === inputFin)) {
              _context3.next = 118;
              break;
            }

            if (!autoOutput) {
              _context3.next = 117;
              break;
            }

            _target2.output += '-' + _target2.platform;
            _context3.next = 118;
            break;

          case 117:
            throw (0, _log.wasReported)('Refusing to overwrite input ' + inputFin);

          case 118:
            _iteratorNormalCompletion5 = true;
            _context3.next = 110;
            break;

          case 121:
            _context3.next = 127;
            break;

          case 123:
            _context3.prev = 123;
            _context3.t3 = _context3['catch'](108);
            _didIteratorError5 = true;
            _iteratorError5 = _context3.t3;

          case 127:
            _context3.prev = 127;
            _context3.prev = 128;

            if (!_iteratorNormalCompletion5 && _iterator5.return) {
              _iterator5.return();
            }

          case 130:
            _context3.prev = 130;

            if (!_didIteratorError5) {
              _context3.next = 133;
              break;
            }

            throw _iteratorError5;

          case 133:
            return _context3.finish(130);

          case 134:
            return _context3.finish(127);

          case 135:

            // fetch targets

            _iteratorNormalCompletion6 = true;
            _didIteratorError6 = false;
            _iteratorError6 = undefined;
            _context3.prev = 138;
            _iterator6 = (0, _getIterator3.default)(targets);

          case 140:
            if (_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done) {
              _context3.next = 152;
              break;
            }

            _target3 = _step6.value;

            _target3.forceBuild = forceBuild;
            _context3.next = 145;
            return needWithDryRun(_target3);

          case 145:
            f = _target3.fabricator = fabricatorForTarget(_target3);

            f.forceBuild = forceBuild;
            _context3.next = 149;
            return needWithDryRun(f);

          case 149:
            _iteratorNormalCompletion6 = true;
            _context3.next = 140;
            break;

          case 152:
            _context3.next = 158;
            break;

          case 154:
            _context3.prev = 154;
            _context3.t4 = _context3['catch'](138);
            _didIteratorError6 = true;
            _iteratorError6 = _context3.t4;

          case 158:
            _context3.prev = 158;
            _context3.prev = 159;

            if (!_iteratorNormalCompletion6 && _iterator6.return) {
              _iterator6.return();
            }

          case 161:
            _context3.prev = 161;

            if (!_didIteratorError6) {
              _context3.next = 164;
              break;
            }

            throw _iteratorError6;

          case 164:
            return _context3.finish(161);

          case 165:
            return _context3.finish(158);

          case 166:

            if (dryRunResults.fetched && !dryRunResults.built) {
              _log.log.info('Fetching base Node.js binaries to: ~/.pkg-cache');
            }

            _iteratorNormalCompletion7 = true;
            _didIteratorError7 = false;
            _iteratorError7 = undefined;
            _context3.prev = 170;
            _iterator7 = (0, _getIterator3.default)(targets);

          case 172:
            if (_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done) {
              _context3.next = 187;
              break;
            }

            _target4 = _step7.value;
            _context3.next = 176;
            return needViaCache(_target4);

          case 176:
            _target4.binaryPath = _context3.sent;
            _f = _target4.fabricator;
            _context3.next = 180;
            return needViaCache(_f);

          case 180:
            _f.binaryPath = _context3.sent;

            if (!(_f.platform !== 'win')) {
              _context3.next = 184;
              break;
            }

            _context3.next = 184;
            return (0, _chmod.plusx)(_f.binaryPath);

          case 184:
            _iteratorNormalCompletion7 = true;
            _context3.next = 172;
            break;

          case 187:
            _context3.next = 193;
            break;

          case 189:
            _context3.prev = 189;
            _context3.t5 = _context3['catch'](170);
            _didIteratorError7 = true;
            _iteratorError7 = _context3.t5;

          case 193:
            _context3.prev = 193;
            _context3.prev = 194;

            if (!_iteratorNormalCompletion7 && _iterator7.return) {
              _iterator7.return();
            }

          case 196:
            _context3.prev = 196;

            if (!_didIteratorError7) {
              _context3.next = 199;
              break;
            }

            throw _iteratorError7;

          case 199:
            return _context3.finish(196);

          case 200:
            return _context3.finish(193);

          case 201:

            // tuple

            tuple = void 0;


            if (configJson) {
              tuple = {
                config: configJson,
                base: _path2.default.dirname(config)
              };
            } else {
              tuple = {
                config: inputJson || {},
                base: _path2.default.dirname(input) // not `inputBin` because only `input`
              }; // is the place for `inputJson`
            }

            // records

            _context3.next = 205;
            return (0, _walker2.default)({
              tuple: tuple, input: inputFin
            });

          case 205:
            records = _context3.sent;
            stripes = {};
            _iteratorNormalCompletion8 = true;
            _didIteratorError8 = false;
            _iteratorError8 = undefined;
            _context3.prev = 210;
            _iterator8 = (0, _getIterator3.default)(targets);

          case 212:
            if (_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done) {
              _context3.next = 223;
              break;
            }

            _target5 = _step8.value;
            slash = _target5.platform === 'win' ? '\\' : '/';

            _target5.slash = slash;

            if (stripes[slash]) {
              _context3.next = 220;
              break;
            }

            _context3.next = 219;
            return (0, _packer2.default)({ records: records, slash: slash });

          case 219:
            stripes[slash] = _context3.sent;

          case 220:
            _iteratorNormalCompletion8 = true;
            _context3.next = 212;
            break;

          case 223:
            _context3.next = 229;
            break;

          case 225:
            _context3.prev = 225;
            _context3.t6 = _context3['catch'](210);
            _didIteratorError8 = true;
            _iteratorError8 = _context3.t6;

          case 229:
            _context3.prev = 229;
            _context3.prev = 230;

            if (!_iteratorNormalCompletion8 && _iterator8.return) {
              _iterator8.return();
            }

          case 232:
            _context3.prev = 232;

            if (!_didIteratorError8) {
              _context3.next = 235;
              break;
            }

            throw _iteratorError8;

          case 235:
            return _context3.finish(232);

          case 236:
            return _context3.finish(229);

          case 237:

            _log.log.debug('Targets:', (0, _stringify2.default)(targets));

            _iteratorNormalCompletion9 = true;
            _didIteratorError9 = false;
            _iteratorError9 = undefined;
            _context3.prev = 241;
            _iterator9 = (0, _getIterator3.default)(targets);

          case 243:
            if (_iteratorNormalCompletion9 = (_step9 = _iterator9.next()).done) {
              _context3.next = 257;
              break;
            }

            _target6 = _step9.value;
            _context3.next = 247;
            return (0, _fsPromise.mkdirp)(_path2.default.dirname(_target6.output));

          case 247:
            _context3.next = 249;
            return (0, _fsPromise.remove)(_target6.output);

          case 249:
            _context3.next = 251;
            return (0, _producer2.default)({ stripe: stripes[_target6.slash], options: options, target: _target6 });

          case 251:
            if (!(_target6.platform !== 'win')) {
              _context3.next = 254;
              break;
            }

            _context3.next = 254;
            return (0, _chmod.plusx)(_target6.output);

          case 254:
            _iteratorNormalCompletion9 = true;
            _context3.next = 243;
            break;

          case 257:
            _context3.next = 263;
            break;

          case 259:
            _context3.prev = 259;
            _context3.t7 = _context3['catch'](241);
            _didIteratorError9 = true;
            _iteratorError9 = _context3.t7;

          case 263:
            _context3.prev = 263;
            _context3.prev = 264;

            if (!_iteratorNormalCompletion9 && _iterator9.return) {
              _iterator9.return();
            }

          case 266:
            _context3.prev = 266;

            if (!_didIteratorError9) {
              _context3.next = 269;
              break;
            }

            throw _iteratorError9;

          case 269:
            return _context3.finish(266);

          case 270:
            return _context3.finish(263);

          case 271:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this, [[87, 91, 95, 103], [96,, 98, 102], [108, 123, 127, 135], [128,, 130, 134], [138, 154, 158, 166], [159,, 161, 165], [170, 189, 193, 201], [194,, 196, 200], [210, 225, 229, 237], [230,, 232, 236], [241, 259, 263, 271], [264,, 266, 270]]);
  }));

  return function exec(_x3) {
    return _ref3.apply(this, arguments);
  };
}();

var _fsPromise = require('fs-promise');

var _log = require('./log.js');

var _pkgFetch = require('pkg-fetch');

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _help = require('./help');

var _help2 = _interopRequireDefault(_help);

var _common = require('../prelude/common.js');

var _minimist = require('minimist');

var _minimist2 = _interopRequireDefault(_minimist);

var _packer = require('./packer.js');

var _packer2 = _interopRequireDefault(_packer);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _chmod = require('./chmod.js');

var _producer = require('./producer.js');

var _producer2 = _interopRequireDefault(_producer);

var _walker = require('./walker.js');

var _walker2 = _interopRequireDefault(_walker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// http://www.openwall.com/lists/musl/2012/12/08/4

var hostArch = _pkgFetch.system.hostArch,
    hostPlatform = _pkgFetch.system.hostPlatform,
    isValidNodeRange = _pkgFetch.system.isValidNodeRange,
    knownArchs = _pkgFetch.system.knownArchs,
    knownPlatforms = _pkgFetch.system.knownPlatforms,
    toFancyArch = _pkgFetch.system.toFancyArch,
    toFancyPlatform = _pkgFetch.system.toFancyPlatform;

var hostNodeRange = 'node' + process.version.match(/^v(\d+)/)[1];

function parseTargets(items) {
  // node6-macos-x64,node6-linux-x64
  if (!items) return [];
  if (Array.isArray(items)) {
    throw (0, _log.wasReported)('Something is wrong near ' + items[0]);
  }
  var targets = [];
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = (0, _getIterator3.default)(items.split(',')), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var item = _step.value;

      var target = {
        nodeRange: hostNodeRange,
        platform: hostPlatform,
        arch: hostArch
      };
      if (item !== 'host') {
        var _iteratorNormalCompletion2 = true;
        var _didIteratorError2 = false;
        var _iteratorError2 = undefined;

        try {
          for (var _iterator2 = (0, _getIterator3.default)(item.split('-')), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var token = _step2.value;

            if (!token) continue;
            if (isValidNodeRange(token)) {
              target.nodeRange = token;
              continue;
            }
            var p = toFancyPlatform(token);
            if (knownPlatforms.indexOf(p) >= 0) {
              target.platform = p;
              continue;
            }
            var a = toFancyArch(token);
            if (knownArchs.indexOf(a) >= 0) {
              target.arch = a;
              continue;
            }
            throw (0, _log.wasReported)('Unknown token \'' + token + '\' in \'' + item + '\'');
          }
        } catch (err) {
          _didIteratorError2 = true;
          _iteratorError2 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion2 && _iterator2.return) {
              _iterator2.return();
            }
          } finally {
            if (_didIteratorError2) {
              throw _iteratorError2;
            }
          }
        }
      }
      targets.push(target);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return targets;
}

function stringifyTarget(target) {
  var nodeRange = target.nodeRange,
      platform = target.platform,
      arch = target.arch;

  return nodeRange + '-' + platform + '-' + arch;
}

function differentParts(targets) {
  var nodeRanges = {};
  var platforms = {};
  var archs = {};
  var _iteratorNormalCompletion3 = true;
  var _didIteratorError3 = false;
  var _iteratorError3 = undefined;

  try {
    for (var _iterator3 = (0, _getIterator3.default)(targets), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
      var target = _step3.value;

      nodeRanges[target.nodeRange] = true;
      platforms[target.platform] = true;
      archs[target.arch] = true;
    }
  } catch (err) {
    _didIteratorError3 = true;
    _iteratorError3 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion3 && _iterator3.return) {
        _iterator3.return();
      }
    } finally {
      if (_didIteratorError3) {
        throw _iteratorError3;
      }
    }
  }

  var result = {};
  if ((0, _keys2.default)(nodeRanges).length > 1) {
    result.nodeRange = true;
  }
  if ((0, _keys2.default)(platforms).length > 1) {
    result.platform = true;
  }
  if ((0, _keys2.default)(archs).length > 1) {
    result.arch = true;
  }
  return result;
}

function stringifyTargetForOutput(output, target, different) {
  var a = [output];
  if (different.nodeRange) a.push(target.nodeRange);
  if (different.platform) a.push(target.platform);
  if (different.arch) a.push(target.arch);
  return a.join('-');
}

function fabricatorForTarget(target) {
  var nodeRange = target.nodeRange,
      arch = target.arch;

  return { nodeRange: nodeRange, platform: hostPlatform, arch: arch };
}

var dryRunResults = {};

var targetsCache = {};